clang 8.0.0

Public Member Functions | Protected Member Functions | Friends | List of all members
clang::ento::SMTExpr Class Referenceabstract

Generic base class for SMT exprs. More...

`#include "clang/StaticAnalyzer/Core/PathSensitive/SMTExpr.h"`

## Public Member Functions
| SMTExpr ()=default
virtual | ~SMTExpr ()=default
bool | operator< (const SMTExpr &Other) const
virtual void | Profile (llvm::FoldingSetNodeID &ID) const
virtual void | print (raw_ostream &OS) const =0
LLVM_DUMP_METHOD void | dump () const

## Protected Member Functions
virtual bool | equal_to (SMTExpr const &other) const =0
| Query the SMT solver and returns true if two sorts are equal (same kind and bit width). More...

## Friends
bool | operator== (SMTExpr const &LHS, SMTExpr const &RHS)

## Detailed Description

Generic base class for SMT exprs.

Definition at line 25 of file SMTExpr.h.

## Constructor & Destructor Documentation

## ◆ SMTExpr()

clang::ento::SMTExpr::SMTExpr | ( |  | ) |
| default

## ◆ ~SMTExpr()

virtual clang::ento::SMTExpr::~SMTExpr | ( |  | ) |
| virtual default

## Member Function Documentation

## ◆ dump()

LLVM_DUMP_METHOD void clang::ento::SMTExpr::dump | ( |  | ) | const
| inline

Definition at line 48 of file SMTExpr.h.

References equal_to(), and print().

## ◆ equal_to()

virtual bool clang::ento::SMTExpr::equal_to | ( | SMTExpr const & | other | ) | const
| protected pure virtual

Query the SMT solver and returns true if two sorts are equal (same kind and bit width).

This does not check if the two sorts are the same objects.

Referenced by dump().

## ◆ operator<()

bool clang::ento::SMTExpr::operator< | ( | const SMTExpr & | Other | ) | const
| inline

Definition at line 30 of file SMTExpr.h.

References Profile().

## ◆ print()

virtual void clang::ento::SMTExpr::print | ( | raw_ostream & | OS | ) | const
| pure virtual

Referenced by dump().

## ◆ Profile()

virtual void clang::ento::SMTExpr::Profile | ( | llvm::FoldingSetNodeID & | ID | ) | const
| inline virtual

Definition at line 37 of file SMTExpr.h.

Referenced by operator<().

## Friends And Related Function Documentation

## ◆ operator==

bool operator== | ( | SMTExpr const & | LHS,
|  | SMTExpr const & | RHS
| ) |  |
| friend

Definition at line 42 of file SMTExpr.h.

The documentation for this class was generated from the following file:

- include/clang/StaticAnalyzer/Core/PathSensitive/SMTExpr.h